/**
 * JavaScript module for the sg-vimeo plugin
 *
 * @deprecated since version 1.1.0 and will be removed in 2.0.0
 */
module.exports = function() {
	'use strict';

	const $ = require('jquery');
	require('magnific-popup');

	/**
	 * Initialize the whole Popup setup
	 */
	function init(section) {
		$(`${section || ''} .sg-vimeo-item`).each(function(index, item) {
			let $vimeoItem = $(item),
				viewportWidth = Math.max(document.documentElement.clientWidth || 0, window.innerWidth || 0);
			if (($vimeoItem.data('disable-lightbox') && viewportWidth >= 680) ||
				($vimeoItem.data('disable-lightbox-mobile') && viewportWidth < 680)
			) {
				$vimeoItem.on('click', replaceThumbnailWithVideo);
			} else {
				$vimeoItem.magnificPopup({
					type: 'iframe',
					iframe: {
						markup: '<div class="mfp-iframe-scaler">' +
							'<div class="mfp-close"></div>' +
							'<iframe class="mfp-iframe" frameborder="0" allowfullscreen allow="autoplay; fullscreen *; picture-in-picture"></iframe>' +
							'</div>',
						patterns: {
							vimeo: {
								index: 'vimeo.com/',
								id: '/',
								src: 'https://player.vimeo.com/video/%id%?autoplay=1&dnt=1'
							}
						}
					}
				});
			}
		});
	}

	/**
	 * Replaces the given element behind the event with a vimeo video.
	 *
	 * @param {Event} event
	 */
	function replaceThumbnailWithVideo(event) {
		event.preventDefault();
		let $vimeoItem = $(event.currentTarget);

		// This needs to be done, because the height of inline elements is always 0, if on auto...
		// $vimeoItem.css('display', 'block');

		let queryString = $vimeoItem.attr('data-video-id'),
			$thumbnailElement = $vimeoItem.find('.sg-vimeo-image'),
			width = $thumbnailElement.outerWidth(),
			height = $thumbnailElement.outerHeight();
		$thumbnailElement.replaceWith('<div class="sg-vimeo-item sg-card-shadow" ' +
			'style="height: ' + height + 'px; width: ' + width + 'px;">' +
			'<div class="embed-container" style="padding-bottom: calc(' + height + ' / ' + width + '  * 100%);">' +
			'<iframe ' +
			'width="' + width + '" height="' + height + '" ' +
			'src="https://player.vimeo.com/video/' + queryString + '?dnt=1" frameborder="0" ' +
			'allow="autoplay; fullscreen; picture-in-picture" allowfullscreen>' +
			'</iframe>' +
			'</div></div>');
	}

	init();
};
